/*---------------------------------------------------------------------------

    main.h
    
    Copyright (c) 2007 by Martin Pernter (iw3aut@yahoo.it)
    
    main.h defines the DLL global values and variables used for interfacing
    between WinRAD and the PM Software Defined Radio  using the PIC18F4550 USB
    chip and the Si570 + CY22394 clock generators.
    
    
    GPL

    This file is part of ExtIO_PMSDR.dll.

    ExtIO_PMSDR.dll is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    ExtIO_PMSDR.dll is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
  ---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------

#define DLL_VERSION "2.0 rev 4"

#include <stdio.h>
#include "codeDeviceManager.h"
#include "panel.h"


// Device initialisation settings
#define DLL_DEVICE_NAME "PMSDR"
#define DLL_DEVICE_TYPE "PIC18F4550 USB 2.0"
#define DLL_TYPE_DAC 3
#define DLL_TYPE_NODAC 4

// Device sampling rate settings
#define DLL_SR_NONE 0

// Winrad callback definitions
#define WINRAD_STATUS_NONE 0
#define WINRAD_STATUS_SR_CHANGED 100
#define WINRAD_STATUS_LO_CHANGED 101

// Frequency setting definitions
#define DLL_DEF_FREQ 7050000
#define DLL_MIN_FREQ 50000
#define DLL_MAX_FREQ 100000000
#define SI570_MIN_FREQ 2500000
#define DLL_FREQ_TOLOW -1
#define DLL_FREQ_OK 0
#define DLL_FREQ_TOHIGH 1
#define DLL_STEP 100

// Library wide variables
//DeviceManager  deviceManager;        
  //extern long LOfreq;
 
  extern void (* CallBack)(int, int, float, short *);

#endif
