/*---------------------------------------------------------------------------

    pmlog.cpp
    
    Copyright (c) 2008 by M. Pernter (iw3aut@yahoo.it)
    
    pmlog.cpp is a simple Log interface

    GPL

    This file is part of ExtIO_PMSDR.dll.

    ExtIO_PMSDR.dll is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    ExtIO_ElektorSDR.dll is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Martin Pernter      15/09/08    
  ---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <vcl.h>
#include <vector>
using std::vector;
#include "main.h"
#pragma hdrstop
//#include "KBDecl.h"
#include "pmlog.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormPMLog *FormPMLog;

vector<logdata> logvector;
//#include "KBForms.h"


#include <string>

AnsiString Default_Dir=".\\";
AnsiString Default_FileName="pmlog.dat";
AnsiString Default_Filter="Log-Files (*.dat)|*.dat";

//---------------------------------------------------------------------------
__fastcall TFormPMLog::TFormPMLog(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormPMLog::initGrid()
{

StringGrid1->Cells[1][0]=LabelFrequency->Caption;
StringGrid1->ColWidths[1]=EditFrequency->Width;
StringGrid1->Cells[2][0]=LabelMode->Caption;
StringGrid1->ColWidths[2]=ComboBoxMode->Width;
StringGrid1->Cells[3][0]=LabelShift->Caption;
StringGrid1->ColWidths[3]=EditShift->Width;
StringGrid1->Cells[4][0]=LabelCall->Caption;
StringGrid1->ColWidths[4]=EditCall->Width;
StringGrid1->Cells[5][0]=LabelDate->Caption;
StringGrid1->ColWidths[5]=EditDate->Width;
StringGrid1->Cells[6][0]=LabelTime->Caption;
StringGrid1->ColWidths[6]=EditTime->Width;

}


void __fastcall TFormPMLog::vector2grid()
{
StringGrid1->RowCount=1;
for (unsigned int i=0; i<logvector.size();i++)
   {
    StringGrid1->Cells[1][StringGrid1->RowCount]=logvector[i].frequency;
    StringGrid1->Cells[2][StringGrid1->RowCount]=logvector[i].mode;
    StringGrid1->Cells[3][StringGrid1->RowCount]=logvector[i].shift;
    StringGrid1->Cells[4][StringGrid1->RowCount]=logvector[i].call;
    StringGrid1->Cells[5][StringGrid1->RowCount]=logvector[i].date;
    StringGrid1->Cells[6][StringGrid1->RowCount]=logvector[i].time;
    StringGrid1->RowCount++;
   }

}

void __fastcall TFormPMLog::FormCreate(TObject *Sender)
{
OpenDialog1->Filter = Default_Filter;
OpenDialog1->FileName=Default_FileName;
OpenDialog1->InitialDir=Default_Dir;
logdata *Daten = new logdata;
//int i=1;

logvector.clear();
//ShowMessage("FORMCREATE");

if (!FileExists(OpenDialog1->FileName))
    {
     ShowMessage("Logfile: "+OpenDialog1->FileName+ " not found!");
     //log_file = new TFileStream(OpenDialog1->FileName,fmCreate);
     StringGrid1->RowCount=1;
     }
else
    {
     log_file = new TFileStream(OpenDialog1->FileName,fmOpenRead);
     while (log_file->Read(Daten,sizeof(logdata)))
         {
           logvector.push_back(*Daten);
         }
     delete log_file;
     
     vector2grid();
     }

FormPMLog->Caption="PMLog for WinRad -> "+OpenDialog1->FileName;


initGrid();
delete Daten;


}
//---------------------------------------------------------------------------

void __fastcall TFormPMLog::Open1Click(TObject *Sender)
{
OpenDialog1->Filter = Default_Filter;
OpenDialog1->FileName=Default_FileName;
OpenDialog1->InitialDir=Default_Dir;
logdata *Daten = new logdata;

if (OpenDialog1->Execute())
  {

   if (FileExists(OpenDialog1->FileName))
      {
        log_file = new TFileStream(OpenDialog1->FileName,fmOpenRead);
        logvector.clear();
        while (log_file->Read(Daten,sizeof(logdata)))
         {
           logvector.push_back(*Daten);
         }
        delete log_file;
        vector2grid();
      }

  }

}
//---------------------------------------------------------------------------
  

void __fastcall TFormPMLog::ButtonAddClick(TObject *Sender)
{
logdata *Daten = new logdata;

   strcpy(Daten->frequency,EditFrequency->Text.c_str());
   strcpy(Daten->mode,ComboBoxMode->Text.c_str());
   strcpy(Daten->shift,EditShift->Text.c_str());
   strcpy(Daten->call,EditCall->Text.c_str());
   strcpy(Daten->date,EditDate->Text.c_str());
   strcpy(Daten->time,EditTime->Text.c_str());
   strcpy(Daten->lo_frequency,IntToStr(GetHWLO()).c_str() );
   //Daten->if_gain;
   //StringGrid1->RowCount++;
   logvector.push_back(*Daten);
   vector2grid();
}
//---------------------------------------------------------------------------



void __fastcall TFormPMLog::StringGrid1SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
     EditFrequency->Text=StringGrid1->Cells[1][ARow];
     ComboBoxMode->Text=StringGrid1->Cells[2][ARow];
     current_ARow = ARow;
}
//---------------------------------------------------------------------------


void __fastcall TFormPMLog::StringGrid1DblClick(TObject *Sender)
{
        AnsiString t = EditFrequency->Text;
        t=t.SubString(1,t.Pos(' ')-1);
        t.Trim();
        t.Delete(t.Pos(','),1);
        t.TrimRight();
        EditDate->Text = EditFrequency->Text.c_str();
        EditDate->Text = t;
        long freq=StrToInt(t);
        SetHWLO(freq-10000); // set LO and shift spectrum 10kHz to right
        (* CallBack)(-1, 101, 0, NULL);
        (* CallBack)(-1, 105, 0, NULL);
        (* CallBack)(-1, 106, 0, NULL);
  }
//---------------------------------------------------------------------------

void __fastcall TFormPMLog::Save1Click(TObject *Sender)
{
SaveDialog1->Filter = Default_Filter;
SaveDialog1->FileName=Default_FileName;
SaveDialog1->InitialDir=Default_Dir;

unsigned int i;
if (!FileExists(SaveDialog1->FileName))
    {
    if (SaveDialog1->Execute())
        {
          ShowMessage("Create new Logfile: "+SaveDialog1->FileName);
          log_file = new TFileStream(SaveDialog1->FileName,fmCreate);
          for (i=0; i<logvector.size();i++)
              {
                log_file->Write(&logvector[i],sizeof(logdata));
              }
     delete log_file;
     }
   }
else
    {
       log_file = new TFileStream(SaveDialog1->FileName,fmCreate);
            //log_file->WriteComponentRes("test",StringGrid1);
       for (i=0; i<logvector.size();i++)
              {
                log_file->Write(&logvector[i],sizeof(logdata));
              }
       delete log_file;
       //ShowMessage(IntToStr(i)+" Records stored");
     }

}
//---------------------------------------------------------------------------


void __fastcall TFormPMLog::Remove1Click(TObject *Sender)
{
 if (logvector.size()<1 || (current_ARow==0)) return;
vector<logdata>::iterator pos = &logvector.at(current_ARow-1);

        logvector.erase(pos);
        vector2grid();
        
}
//---------------------------------------------------------------------------



void __fastcall TFormPMLog::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        //logvector.clear();
        //StringGrid1->RowCount=1;
        //Action = caFree;
        return;
}
//---------------------------------------------------------------------------


void __fastcall TFormPMLog::FormShow(TObject *Sender)
{
    //ShowMessage("SHOW");
    return;
}
//---------------------------------------------------------------------------

